<?php
if (defined('_PS_CONFIG_DIR_')) {
    require_once _PS_CONFIG_DIR_ . 'config.inc.php';
}

if (defined('_PS_MODULE_DIR_')) {
    include _PS_MODULE_DIR_ . '/expay/events/expay_event_handler.php';
    include _PS_MODULE_DIR_ . '/expay/classes/expay_webhooks.php';
}

class ExpayWebhooksModuleFrontController extends ModuleFrontController
{
    protected $expay_event_handler;
    protected $expay_webhooks;

    public function __construct()
    {
        parent::__construct();

        $this->setExpayEventHandler(new ExpayEventHandler());
        $this->setExpayWebhooks(new ExpayWebhooks());
    }

    public function setExpayEventHandler($expay_event_handler)
    {
        $this->expay_event_handler = $expay_event_handler;
    }

    public function setExpayWebhooks($expay_webhooks)
    {
        $this->expay_webhooks = $expay_webhooks;
    }

    protected function isRequestValid($request_body)
    {
        return !empty($request_body);
    }

    public function postProcess()
    {
        $this->setTemplate('module:expay/views/templates/front/webhooks.tpl');

        $request_body = $this->expay_webhooks->getRequestBody();

        if (! $this->isRequestValid($request_body)) {
            $this->expay_webhooks->sendRawHeaderAsBadRequest();
            return;
        }

        $this->expay_event_handler->handle($request_body);
    }
}