<?php
require_once __DIR__ . '/expay_base_event.php';

class ExpayEventCheck extends ExpayBaseEvent {

    public function handle($event)
    {
        $order = new Order($event['order']);
        if(! $this->isOrderValid($order)) {
            $this->sendResponse(475, 'Payment with the specified parameters can not be processed');

            return false;
        }

        if (! $this->isHashValid($event)) {
            $this->sendResponse(401, 'Invalid hash');

            return false;
        }

        if (! $this->amountMatching($order, $event)) {
            $this->sendResponse(475, 'Payment with the specified parameters can not be processed');

            return false;
        }

        if ($this->isOrderCanceled($order)) {
            $this->sendResponse(475, 'Payment with the specified parameters can not be processed');

            return false;
        }

        if ($this->isOrderPaid($order)) {
            $this->sendResponse(475, 'Payment with the specified parameters can not be processed');

            return false;
        }

        $message = 'Expay Webhooks: check of order#' . $order->id . ' is succeeded';
        $this->expay_logger->add($message);

        $this->sendResponse(270, 'account exist');

        return true;
    }
}

