<?php
if (defined('_PS_CLASS_DIR_')) {
    require_once _PS_CLASS_DIR_ . '/order/Order.php';
}

if (defined('_PS_MODULE_DIR_')) {
    require_once _PS_MODULE_DIR_ . '/expay/events/expay_event_check.php';
    require_once _PS_MODULE_DIR_ . '/expay/events/expay_event_pay.php';
    require_once _PS_MODULE_DIR_ . '/expay/classes/expay_logger.php';
}

class ExpayEventHandler
{
    private $expay_logger;

    public function __construct()
    {
        $this->expay_logger = new ExpayLogger();
    }

    public function handle($event)
    {
        if (!isset($event['method'])) {
            return false;
        }

        switch ($event['method']) {
            case 'check':
                $message = 'Expay Webhooks: an event CHECK (order#' . $event['order'] . ') has been caught.';
                $this->expay_logger->add($message);
                $expay_event = new ExpayEventCheck();
                break;

            case 'pay':
                $message = 'Expay Webhooks: an event PAY (order#' . $event['order'] . ') has been caught.';
                $this->expay_logger->add($message);
                $expay_event = new ExpayEventPay();
                break;

            default:
                return false;
        }

        return $expay_event->handle($event);
    }
}