(function() {
    var expayDisplaySelectBankMessage = function expayDisplaySelectBankMessage() {
        $.fancybox.open([
                {
                    type: 'inline',
                    autoScale: true,
                    minHeight: 30,
                    content: $('#expay-select-bank-message').html(),
                }],
            {
                padding: 0,
            });
    };

    var expayDisplayInvalidValueMessage = function expayDisplayInvalidValueMessage() {
        $.fancybox.open([
                {
                    type: 'inline',
                    autoScale: true,
                    minHeight: 30,
                    content: $('#expay-invalid-value-message').html(),
                }],
            {
                padding: 0,
            });
    };

    var expayDisplayEmptyFieldMessage = function expayDisplayEmptyFieldMessage() {
        $.fancybox.open([
                {
                    type: 'inline',
                    autoScale: true,
                    minHeight: 30,
                    content: $('#expay-empty-value-message').html(),
                }],
            {
                padding: 0,
            });
    };

    var expayHasAnyBankSelected = function expayHasAnyBankSelected() {
        let paymentOptionList = $('[name="paymentMethod"]:visible');

        return !!paymentOptionList.filter(":checked").length;
    };

    var isExpayOptionSelected = function isExpayOptionSelected() {
        let expayOptions = $('[data-module-name^="expay_"]');

        return !!expayOptions.filter(":checked").length
    };

    let validator = function validator() {
        var attrs = $('.attr:visible');
        if (!attrs) {
            return true;
        }

        let result = true;
        attrs.each(function() {
            var $item = $(this),
                regText = $item.data('regexp') + '';

            if (regText) {
                result = (new RegExp(regText)).test($item.val());
            } else if ($item.data('required')) {
                result = !!$item.val();
            }

            if (!$item.val() && $item.prop('required')) {
                $item.addClass('invalid');
                expayDisplayEmptyFieldMessage();
                return false;
            }

            if (!result) {
                if ($item.val()) {
                    $item.addClass('invalid');
                    expayDisplayInvalidValueMessage();
                    return false;
                } else {
                    result = true;
                }
            }
        });
        return result;
    };

    $(function() {
        let $paymentConfirmationButton = $('#payment-confirmation button');

        $('.attr').on('click', function() {
            $(this).removeClass('invalid');
        });

        $('.PaymentMethodRadio').change(function() {
            var $radio = $(this);
            if ($radio.is(':checked')) {
                ($radio.siblings('.attrList')).children('.attr').
                    removeAttr('disabled');
            } else {
                ($radio.siblings('.attrList')).children('.attr').
                    attr('disabled', 'disabled');
            }
        });

        $paymentConfirmationButton.on('click', function(event) {
            let $canProceed = true;

            if (!isExpayOptionSelected()) {
                $canProceed = false;
            }

            if ($canProceed && !expayHasAnyBankSelected()) {
                expayDisplaySelectBankMessage();
                $canProceed = false;
            }

            if ($canProceed && !validator()) {
                $canProceed = false;
            }

            if (!$canProceed) {
                event.preventDefault();
                event.stopPropagation();
            }
        });
    });
})();